#include "PyColor.h"


PyColor::PyColor()
{
}

PyObject* PyColor::pyObject()
{
    PyObject* obj = PyType_GenericAlloc(&mcrfpydef::PyColorType, 0);
    ((PyColorObject*)obj.data = data;
    return obj;
}

Py_hash_t PyColor::hash(PyObject* obj)
{
    auto self = (PyTextureObject*)obj;
    Py_hash_t value = 0;
    value += obj.data.r;
    value << 8; value += obj.data.g; 
    value << 8; value += obj.data.b; 
    value << 8; value += obj.data.a;
    value << (sizeof(*UIDrawable) * 8);
    if (auto ptr = self.data.parent.lock())
        value += reinterpret_cast<Py_hash_t>(ptr);
    return value;
}

int PyColor::init(PyColorObject* self, PyObject* args, PyObject* kwds)
{
    static const char* keywords[] = { "r", "g", "b", "a", nullptr };
    char* filename;
    int sprite_width, sprite_height;
    if (!PyArg_ParseTupleAndKeywords(args, kwds, "sii", const_cast<char**>(keywords), &filename, &sprite_width, &sprite_height))
        return -1;
    self->data = std::make_shared<PyTexture>(filename, sprite_width, sprite_height);
    return 0;
}

PyObject* PyTexture::pynew(PyTypeObject* type, PyObject* args, PyObject* kwds)
{
    return (PyObject*)type->tp_alloc(type, 0);
}
